﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TXTextControl.DocumentServer.Fields;
using System.Data.OleDb;
using TXTextControl;

namespace tx_win_demo
{
    public partial class tx_linkage : Form
    {
        public tx_linkage()
        {
            InitializeComponent();
        }

        TXTextControl.ApplicationFieldCollection afc;

        private void Form1_Load(object sender, EventArgs e)
        {
            this.textControl1.TextFieldClicked += new TXTextControl.TextFieldEventHandler(textControl1_TextFieldClicked);

            TXTextControl.LoadSettings ls = new TXTextControl.LoadSettings();
            ls.ApplicationFieldFormat = TXTextControl.ApplicationFieldFormat.MSWord;
            ls.ApplicationFieldTypeNames = new string[] { "MERGEFIELD" };
            this.textControl1.Load(AppDomain.CurrentDomain.BaseDirectory + "\\resource\\病历模板的格式－入院录.doc", TXTextControl.StreamType.MSWord, ls);
            afc = this.textControl1.ApplicationFields;

            BindData();
            InsertCombo();
        }

        private void BindData()
        {
            //连接数据库
            string dbconStr = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source=resource\\txdb.mdb";
            OleDbConnection dbcon = new OleDbConnection(dbconStr);
            if (dbcon.State == ConnectionState.Closed)
            {
                dbcon.Open();
            }

            DataTable dt = new DataTable();
            OleDbDataAdapter dbAdapter = new OleDbDataAdapter("select  * from persons", dbcon);

            dbAdapter.Fill(dt);
            mailMerge1.TextComponent = this.textControl1;
            mailMerge1.SearchPath = "";
            mailMerge1.TemplateFile = AppDomain.CurrentDomain.BaseDirectory + "\\resource\\病历模板的格式－入院录.doc";
            mailMerge1.Merge(dt, true);
        }
        DocumentTargetCollection dtc;
        private void InsertCombo()
        {
            dtc = this.textControl1.DocumentTargets;

            foreach (DocumentTarget item in dtc)
            {
                if (item.TargetName == "性别")
                {
                    this.textControl1.Selection.Start = item.Start + 2;
                    this.textControl1.Selection.Length = 1;
                    this.textControl1.Selection.Text = "";
                }
            }

            FormDropDown fddField = new FormDropDown();
            fddField.ApplicationField.Deleteable = false;
            fddField.ApplicationField.Editable = false;
            fddField.ApplicationField.DoubledInputPosition = true;
            fddField.ListEntries = new string[] { "女", "男" };
            fddField.Text = fddField.ListEntries.ElementAt(0);
            textControl1.ApplicationFields.Add(fddField.ApplicationField);
        }

        private void textControl1_TextFieldClicked(object sender, TXTextControl.TextFieldEventArgs e)
        {
            TXTextControl.ApplicationField appField = (TXTextControl.ApplicationField)e.TextField;
            ApplicationFieldActivate(appField);
        }

        private int dpiX = 15;
        private int id = 100;
        private void ApplicationFieldActivate(TXTextControl.ApplicationField ApplicationField)
        {
            textControl1.Controls.Clear();
            switch (ApplicationField.TypeName)
            {
                case "FORMDROPDOWN":
                    FormDropDown fddField = new FormDropDown(ApplicationField);
                    ComboBox cb = new ComboBox();
                    cb.Items.AddRange(fddField.ListEntries.ToArray<string>());
                    Point cbLocation = new Point((fddField.ApplicationField.Bounds.Location.X -
                                                 textControl1.ScrollLocation.X) / dpiX,
                                                 (fddField.ApplicationField.Bounds.Location.Y -
                                                 textControl1.ScrollLocation.Y) / dpiX);

                    cb.Location = cbLocation;
                    cb.Tag = fddField;
                    cb.SelectedText = fddField.ApplicationField.Text;
                    cb.SelectedIndexChanged += new EventHandler(cb_SelectedIndexChanged);
                    cb.LostFocus += new EventHandler(cb_LostFocus);

                    textControl1.Controls.Add(cb);
                    cb.Focus();
                    break;
                default: break;
            }
        }

        void cb_SelectedIndexChanged(object sender, EventArgs e)
        {
            ((FormDropDown)((ComboBox)sender).Tag).Text = ((ComboBox)sender).SelectedItem.ToString();
            ComboBox cb = sender as ComboBox;

            if (cb.SelectedItem.ToString() == "男")
            {
                TableCollection tbc = this.textControl1.Tables;

                foreach (Table item in tbc)
                {
                    TableCellCollection tcs = item.Cells;
                    foreach (TableCell cell in tcs)
                    {
                        if (cell.Text.Contains("月经史"))
                        {
                            this.textControl1.Selection.Start = cell.Start;
                            this.textControl1.Selection.Length = cell.Length;
                            this.textControl1.Selection.ForeColor = Color.White;
                        }
                    }
                }
            }
            else
            {
                TableCollection tbc = this.textControl1.Tables;

                foreach (Table item in tbc)
                {
                    TableCellCollection tcs = item.Cells;
                    foreach (TableCell cell in tcs)
                    {
                        if (cell.Text.Contains("月经史"))
                        {
                            this.textControl1.Selection.Start = cell.Start;
                            this.textControl1.Selection.Length = cell.Length;
                            this.textControl1.Selection.ForeColor = Color.Black;
                        }
                    }
                }
            }
            this.textControl1.Select(0, 0);
            this.textControl1.Controls.Clear();
        }

        void cb_LostFocus(object sender, EventArgs e)
        {
            ((FormDropDown)((ComboBox)sender).Tag).Text = ((ComboBox)sender).Text;
            this.textControl1.Controls.Clear();
        }
    }
}
